' -------------------------------------------------
' WMI Script to prompt the user for the sa password
' when installing the MSDE.
' -------------------------------------------------


Option Explicit

Dim objWMIService   ' The WMI Service object.
Dim objStartup      ' The WMI Process_Startup object for setting process startup options.
Dim objConfig       ' The WMI object for setting process configuration options.
Dim objProcess      ' The WMI Win32_Process object.

Dim objFSO          ' The WMI File System object.
Dim objShell        ' The Shell Application object.
Dim objFolder       ' The folder selected by the user.
Dim objFolderItem
Dim objPath         ' The fully-qualified path to the user-selected folder.
Dim objTempFolder   ' The temporary folder used for storage of the MSDE installer.

Dim strPassword     ' The password for the "sa" user.
Dim strInstance     ' The instance name of the installed MSDE.
Dim strComputer     ' The name of the computer on which this script should execute.
Dim strCommand      ' The complete command-line for running the MSDE installer.
Dim intProcessID    ' The PID of the MSDE installer process.
Dim strWorking      ' The working directory for the MSDE installer process.


Const WINDOW_HANDLE = 0
Const OPTION_ONLY_FOLDERS = 1
Const OverWriteFiles = TRUE
Const NORMAL = 1


' We're working with localhost.
strComputer = "."


' ------------------------------------------------------
' Let the user select a directory into which a temporary
' copy of the MSDE installer will be copied.
' ------------------------------------------------------
Set objShell = CreateObject("Shell.Application")
Set objFolder = objShell.BrowseForFolder(WINDOW_HANDLE, "Select a folder for temporary storage of the MSDE installer:", OPTION_ONLY_FOLDERS)

If IsValue(objFolder) = False Then
   WScript.Quit
End If

Set objFolderItem = objFolder.Self

objPath = objFolderItem.Path
objPath = Replace(objPath, "\", "\\")

strWorking = objPath & "\\MSDE2K"

' ------------------------------------------------
' Copy the installer into the temporary directory.
' ------------------------------------------------
Set objFSO = CreateObject("Scripting.FileSystemObject")
objFSO.CopyFolder "MSDE2K", strWorking, OverWriteFiles

' ---------------------------------------------
' Determine the actual temporary working folder
' ---------------------------------------------
Set objTempFolder = objFSO.GetFolder(strWorking)

' ---------------------------------------------
' Obtain the instance name of this MSDE install
' ---------------------------------------------
strInstance = "<instance name>"
strInstance = InputBox("Enter the MSDE Instance Name", "Install MSDE", strInstance)

If IsEmpty(strInstance) Then
   ' Clean up and exit
   objTempFolder.Delete True
   WScript.Quit
End If

' -------------------------------------------
' Obtain the user password for the sa account
' -------------------------------------------
strPassword = "<password>"
strPassword = InputBox("Enter the SQL Server sa password", "Install MSDE", strPassword)

If IsEmpty(strPassword) Then
   ' Clean up and exit
   objTempFolder.Delete True
   WScript.Quit
End If

' -----------------------
' Build the command-line.
' -----------------------
strCommand = strWorking & "\\setup.exe InstanceName=""" & strInstance & """ sapwd=" & strPassword

' --------------------------------------------
' Connect to WMI and execute the command-line.
' --------------------------------------------
Set objWMIService = GetObject("winmgmts:" & "{impersonationLevel=impersonate}\\" & strComputer & "\root\cimv2")

' Configure startup options.
Set objStartup = objWMIService.Get("Win32_ProcessStartup")
Set objConfig = objStartup.SpawnInstance_
objConfig.ShowWindow = NORMAL

' Start the process.
Set objProcess = objWMIService.Get("Win32_Process")
objProcess.Create strCommand, strWorking, objConfig, intProcessID

WSCript.Quit 


' ----------------------------------------------
' A helper method to detect when the user has
' hit the CANCEL button on the Browse for Folder
' ----------------------------------------------
Function IsValue(obj)
    ' Check whether the value has been returned.
    Dim tmp
    On Error Resume Next
    tmp = " " & obj
    
    If Err <> 0 Then
        IsValue = False
    Else
        IsValue = True
    End If
    
    On Error GoTo 0
End Function
